'''
Created on Nov 25, 2019
Sample structure of run file run.py

@author: cxchu
'''

import sys
import spacy

nlp = spacy.load("en_core_web_sm")

def your_extracting_function(input_file, result_file):
    
    '''
    This function reads the input file (e.g. input.tsv)
    and extracts the required information of all given entity mentions.
    The results is saved in the result file (e.g. results.tsv)
    '''
    fout = open(result_file, 'w', encoding='utf8')
    fin = open(input_file, 'r', encoding='utf8')
    id = 1
    for line in fin.readlines():
        line = line.rstrip()
        
        '''
        baseline: running dependency, return head verb, nominal subject and directed object
        '''
        doc = nlp(line)
        verbs = {};
        
        for token in doc:
            key=token.head.text;
            if(token.head.pos_ == "VERB" and key not in verbs.keys()):
                verbs[key] = {"subject":"","object":""};
            if(token.dep_ == "nsubj" and token.head.pos_ == "VERB"):
                verbs[key]["subject"] = token.text;
                
            elif(token.dep_ == "dobj" and token.head.pos_ == "VERB"):
                verbs[key]["object"] = token.text;
                
        ## print
        if len(verbs) > 0:
            res = ''
            for key, value in verbs.items():
                #print(value)
                if value['subject'] != '' and value['object'] != '':
                    res += str(id) + '\t"' + value["subject"] + '"\t"' + key + '"\t"' + value["object"] + '"\t0\n'
            if res != '':
                fout.write(line + "\n")
                fout.write(res) 
                id += 1
            
        '''
        end baseline
        '''
    fout.close()
    
    
'''
*** other code if needed
'''    
    
    
'''
main function
'''
if __name__ == '__main__':
    if len(sys.argv) != 3:
        raise ValueError('Expected exactly 2 argument: input file and result file')
    your_extracting_function(sys.argv[1], sys.argv[2])
